//*****************************************
// Modu do warstw swiata 2D
// Adam Lasko Zbylitowska Gra 31.12.2006
//*****************************************

unit warstwa;

interface
uses
 OmegaImageList, OmegaSprite, OmegaMap,Windows,controls,extctrls,
 classes;
type
 TTypSwiata=(izometryczny,prostokatny);

 TDaneMApy=record
       typ           :tTypSwiata;
       XCount        :word;//ile kolumn kosci swita
       YCount        :word;//ile wierszy kosci swita
       XSwiataEkranu :byte;//ile kosci widocznych na ekranie w osi X
       YSwiataEkranu :byte;//ile kosci widocznych na ekranie w osi Y
       W1Kosc         :word;//szerokosc kosci swiata warstwy 1
       H1Kosc         :word;//wysokosc kosci swiata  warstwy 1
       W1polKosc      :word;//szerokosc plowy kosci swiata warstwy 1
       H1polKosc      :word;//wysokosc polowy kosci swiata warstwy 1
       W2Kosc         :word;//szerokosc kosci swiata warstwy 2- lub jako dodatkowe pola
       H2Kosc         :word;//wysokosc kosci swiata  warstwy 2
       OmegaSprite    :TOmegaSprite;
       OmegaImageList :TOmegaImageList;
       ImageListItem  :TImageListItem;
       Rozdzielczosc  :TPoint;
       VSYNC          :boolean;
       bpp            :byte;
       fSiatka        :boolean;
       idPanel        :byte;//indeks obrazu panela wyswietlanego w dole swiata
 end;

 TMapa=record
      idKlatka  :integer;//indeks klatki obrazka, -1 to brak obrazka
      idObrazka :integer;//indeks Obrazu zgdny z list OmegaImageList zaadowanego zasobu
      tileWidth,
      tileHeight:integer;//rozmiar klatki przechowyawnego obrazu
      left,
      top       :integer;//wspolrzedne tej klatki wzgledem gornego lwergo rogu kostki swiata
      RGBA:record
       R:byte;
       G:byte;
       B:byte;
       A:byte;
      end;
 end;

 PMapa=^tabTMapa;
 tabTMapa=array of TMapa;//typ tablicowy do przechowywania map warstw swiatow


 TKostkaMapy=class(TSimpleAnimSprite)
      fPokaz:boolean;//dodatkowa flaga rysowania - ukrywania dla edytora swiatow
      typ:TTypSwiata;
      indeks:integer;
      fSiatka:boolean;//falaga pokazywania suiatki
      x0,y0,       //stale wspolrzedne zaczepienia kafla
      dX,dY:single;//wzgledne przesuniecie kafla
      left,
      top    :integer;//wspolrzedne lewego rogu obrazu przekazanego do klatki
      kolumna,wiersz,   //kolumna i wiersz
      RogX,RogY:integer;//wspolrzedne kolumny i wiersza gornego lewego rogu mapy
      idWskMApy   :integer;//indeks wskaznika mapy
      procedure ZmianaKlatki;
   private
      Mapa:tabTMapa;
      procedure RGBA;//oraz left i top obarzu przekazanego do klatki

      procedure RuchWLewo;
      procedure RuchWPrawo;
      procedure RuchWGore;
      procedure RuchWDol;
      procedure Draw;override;
      procedure Move(const MoveCount:single);override;
 end;

var
 Lista:TList;//lista wskaznikow map
 DaneMApy:TDaneMApy;
 skokX,skokY:double;
 typSwiata:TTypSwiata;
 //rzeczywiste wspolrzedne rogu swita, zmieniaja sie pod wplywem jego przesowania
 RogSwiata:record
    x,
    y:single;//wspolrzedne lewego gornego rogu
    kolumna,
    wiersz,
    Indeks:LongInt;//Indeks Klatki lewegogornego rogu
 end;


 procedure TworzMApeWarstwy(const idImage,kol,wier,_01:integer;var A:PMapa);
 function UstawDaneMApy(typSwiata:tTypSwiata;
                       XYCount:TPoint;
                       WH:TPoint;
                       EKranXY:TPoint;
                       OML:TOmegaImageList):TDaneMApy;

implementation
uses unit1,Sysutils;
procedure TKostkaMapy.RGBA;
begin
    Red  :=PMapa(Lista.Items[idWskMApy])^[indeks].RGBA.R;
    Green:=PMapa(Lista.Items[idWskMApy])^[indeks].RGBA.G;
    Blue :=PMapa(Lista.Items[idWskMApy])^[indeks].RGBA.B;
    Alpha:=PMapa(Lista.Items[idWskMApy])^[indeks].RGBA.A;
    left :=PMapa(Lista.Items[idWskMApy])^[indeks].left;
    top  :=PMapa(Lista.Items[idWskMApy])^[indeks].top;
end;

procedure TKostkaMapy.ZmianaKlatki;

begin
   if (RogX>-1)and(RogY>-1)and
          (RogX<DaneMApy.XCount)and(RogY<DaneMApy.YCount)
   then
       Indeks:=RogX+RogY*DaneMApy.XCount
   else
       begin
       Indeks:=-1;
       exit;
       end;
   Image:=DaneMapy.OmegaImageList.ImageList.Items[Pmapa(Lista.Items[idWskMApy])^[indeks].idObrazka];
   ImageIndex  := Pmapa(Lista.Items[idWskMApy])^[indeks].idKlatka;
   //uswta nowe wartoci Red, Green, Blue, Alpha jakie niesie w sobie nowa komrka mapy wiata 
   RGBA;
end;
procedure TKostkaMapy.RuchWLewo;
begin
 //sprzwdz czy ma nastapic skok
 if dx>DaneMapy.W1Kosc  then
 begin
    RogX:=RogX-1;//Kosc przesuwa sie w Lewo a wiat w prawo
    x:=x0;
    dx:=0;
    ZmianaKlatki;

 end;
end;
procedure TKostkaMapy.RuchWPrawo;
begin
 if dx<-DaneMapy.W1Kosc  then
 begin
    RogX:=RogX+1;
    x:=x0;
    dx:=0;
    ZmianaKlatki
 end;
end;
procedure TKostkaMapy.RuchWGore;
begin

 if dy<-DaneMapy.H1Kosc then begin
       RogY:=RogY+2;
       y:=y0;
       dy:=0;
       ZmianaKlatki
    end;
end;
procedure TKostkaMapy.RuchWDol;
begin
 if dy>DaneMapy.H1Kosc  then
    begin
     RogY:=RogY-2;
     y:=y0;
     dy:=0;
     ZmianaKlatki
    end;
end;

procedure TKostkaMapy.Move(const MoveCount:single);
begin
 inherited Move(MoveCount);
 dx:=dx+SkokX;
 dy:=dy+SkokY;
 RuchWLewo;
 RuchWPrawo;
 RuchWGore;
 RuchWDol;
 x:=x0+dx;
 y:=y0+dy;

end;
procedure TKostkaMapy.Draw;
var
 Rect:TRect;
begin
 if fSiatka then begin
    Image.Renderer.OmegaScreen.DrawRectangle(Round(x+1),Round(y+1),Round(x+DAneMApy.W1Kosc-1),Round(y+DAneMApy.H1Kosc-1),
                                             false,1,125,125,125);
    exit;
 end;
 //nie rysuj jesli indeks wskazuje na -1
 if (ImageIndex=-1)or(Indeks=-1)then exit;
 Image.Draw(Round(x+left),Round(y+top),0,0.5,0.5,1,1,Red,Green,Blue,Alpha,ImageIndex,0);
end;
procedure TworzMApeWarstwy(const idImage,kol,wier,_01:integer;var A:PMapa);
var
 i,
 rozmiar:LongInt;
begin
 rozmiar:=kol*wier;
 setLength(A^,rozmiar);
 for i:=0 to rozmiar-1 do begin
     A^[i].idKlatka  :=_01;
     A^[i].idObrazka :=idImage;//standardowo nie bedzi ewyswietlac obrazu z listy o indeksie 0, na -1 wykrzacz si
                               //pod indeksem zero jets obraz przezroczysty
     A^[i].TileWidth :=DAneMApy.W1Kosc;
     A^[i].TileHeight:=DAneMApy.H1Kosc;
     A^[i].left  :=0;
     A^[i].top   :=0;
     A^[i].RGBA.R:=255;
     A^[i].RGBA.G:=255;
     A^[i].RGBA.B:=255;
     A^[i].RGBA.A:=255;
 end;
end;
///////////////////////////////////////////////
function UstawDaneMApy(typSwiata:tTypSwiata;
                       XYCount:TPoint;
                       WH:TPoint;
                       EKranXY:TPoint;
                       OML:TOmegaImageList):TDaneMApy;
begin
 case typSwiata of
  izometryczny:with result do
    begin
       typ:=typSwiata;
       XCount:=XYCount.X;//23;         //liczba klatek mapy swiata w osi X
       YCount:=XYCount.Y;//26;         //liczba klatek mapy swiata w osi Y
       W1Kosc:=WH.X;//128;        //rozmiar klatki mapy w osi x
       H1Kosc:=WH.Y;//64;         //rozmiar klatki mapy w osi Y
       W1polKosc:=WH.X div 2;//64;      //polowa rozmiaru klatki mapy w osi x
       H1polKosc:=WH.Y div 2;//32;      //polowa rozmiaru klatki mapy w osi y
       W2Kosc:=WH.X;//;        //rozmiaru klatki warstwy scian w osi x
       H2Kosc:=Round(0.75*WH.Y);//96;         //rozmiaru klatki warstwy scian w osi y

       XSwiataEkranu  :=EKranXY.X;//8; //liczba klatek widocznych na ekranie w osi x
       YSwiataEkranu  :=EKranXY.Y;//18;//liczba klatek widocznych na ekranie w osi y
       OmegaImageList:=OML;//Lista grafiki
    end;{koniec diagonalny}
  prostokatny:with result do
    begin
       typ:=typSwiata;
       XCount:=XYCount.X;//23;         //liczba klatek mapy swiata w osi X
       YCount:=XYCount.Y;//26;         //liczba klatek mapy swiata w osi Y
       W1Kosc:=WH.X;//128;        //rozmiar klatki mapy w osi x
       H1Kosc:=WH.Y;//64;         //rozmiar klatki mapy w osi Y
       W1polKosc:=WH.X ;//musi byc cay rozmiar
       H1polKosc:=WH.Y ;//ze wzgledu na ruch swiata
       W2Kosc:=WH.X;//;        //rozmiaru klatki warstwy scian w osi x
       H2Kosc:=Round(0.75*WH.Y);//96;         //rozmiaru klatki warstwy scian w osi y

       XSwiataEkranu  :=EKranXY.X;//8; //liczba klatek widocznych na ekranie w osi x
       YSwiataEkranu  :=EKranXY.Y;//18;//liczba klatek widocznych na ekranie w osi y
       OmegaImageList:=OML;//Lista grafiki
    end;{koniec diagonalny}

 end;
end;

end.
